---
name: Design Proposal
about: I have a significant change I would like to propose and discuss before starting
labels: "Status: Untriaged"
---

### When a Change Needs a Design Proposal

A design proposal should be opened any time a change meets one of the following qualifications:

- Significantly changes the user experience of a project in a way that impacts users.
- Significantly changes the underlying architecture of the project in a way that impacts other developers.
- Changes the development or testing process of the project such as a change of CI systems or test frameworks.

### Why We Use This Process

- Allows all interested parties (including any community member) to discuss large impact changes to a project.
- Serves as a durable paper trail for discussions regarding project architecture.
- Forces design discussions to occur before PRs are created.
- Reduces PR refactoring and rejected PRs.

---

<!---  Proposal description and rationale.  -->

## Motivation

<!---
    As a <<user_profile>>,
    I want to <<functionality>>,
    so that <<benefit>>.
 -->

## Specification

<!---  A detailed description of the planned implementation. -->

## Downstream Impact

<!---  Which other tools will be impacted by this work?  -->
