#
# Author:: Tim Smith (tsmith@chef.io>)
# Copyright:: Copyright 2018, Chef Software Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require "spec_helper"

describe Chef::Resource::MacosxService do
  let(:resource) { Chef::Resource::MacosxService.new("chef") }

  it "sets the resource_name to :macosx_service" do
    expect(resource.resource_name).to eql(:macosx_service)
  end

  it "accepts a String for the session_type property" do
    resource.session_type "foo"
    expect(resource.session_type).to eql("foo")
  end

  it "accepts a String for the plist property" do
    resource.plist "foo"
    expect(resource.plist).to eql("foo")
  end
end
